
# Copyright (C) 2006, Martin Sevior <msevior@physics.unimelb.edu.au>.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
import sys

class KeyBindings:
    def __init__(self):
        return
    
    def AbiDefault(self):
        myone = """//
name, AbiDefault

// mse, Button, Context, cick, dblclick, drag, dbldrag,release, doublerelese

mse,B0,CU ,,,cursorDefault,,,,
mse,B0,CT ,,,cursorIBeam,,,,
mse,B0,CL ,,,cursorRightArrow,,,,
mse,B0,CM ,,,cursorIBeam,,,,
mse,B0,CI ,,,cursorImage,,,,
mse,B0,CEM ,,,btn0InlineImage,,,,
mse,B0,CZ ,,,btn0InlineImage,,,,
mse,B0,CF ,,,cursorDefault,,,,
mse,B0,CR ,,,cursorDefault,,,,
mse,B0,CH ,,,hyperlinkStatusBar,,,,
mse,B0,CTV ,,,cursorVline,,,,
mse,B0,CTH ,,,cursorHline,,,,
mse,B0,CTF ,,,btn0Frame,,,,
mse,B0,CPO ,,,btn0Frame,,,,
mse,B0,CVD ,,,btn0VisualText,,,,
mse,B0,CTC ,,,cursorTopCell,,,,
mse,B0,CTO ,,,cursorTOC,,,,
mse,B0,CMA ,,,cursorDefault,,,,

mse,B1, CVD ,cutVisualText,copyVisualText,dragVisualText,dragVisualText,pasteVisualText,pasteVisualText
mse,B1,CVD  C,copyVisualText,cutVisualText,dragVisualText,dragVisualText,pasteVisualText,pasteVisualText
mse,B1,CTF,btn1Frame,btn1Frame,dragFrame,dragFrame,releaseFrame,releaseFrame
mse,B1,CPO,btn1Frame,btn1Frame,dragFrame,dragFrame,releaseFrame,releaseFrame
mse,B1,CI ,selectObject,dlgFmtImage,,,,
mse,B1,CI  C,copyInlineImage,copyInlineImage,dragInlineImage,dragInlineImage,releaseInlineImage,releaseInlineImage
mse,B1,CF ,warpInsPtToXY,selectObject,,,,
mse,B1,CF ,warpInsPtToXY,selectObject,,,,
mse,B1,CT ,warpInsPtToXY,selectWord,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CT  S,extSelToXY,,dragToXY,,endDrag,endDrag
mse,B1,CTO ,selectTOC,warpInsPtToXY,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CL ,selectLine,selectBlock,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CM ,warpInsPtToXY,selectWord,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CM  S,extSelToXY,,dragToXY,,endDrag,endDrag
mse,B1,CM  C,selectWord,,,,endDrag,endDrag
mse,B1,CR ,selectLine,selectBlock,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CH ,warpInsPtToXY,hyperlinkJump,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CV ,warpInsPtToXY,selectWord,dragToXY,dragToXYword,endDrag,endDrag
mse,B1,CZ ,btn1InlineImage,dlgFmtPosImage,dragInlineImage,,releaseInlineImage,releaseInlineImage
mse,B1,CZ  C,copyInlineImage,copyInlineImage,dragInlineImage,dragInlineImage,releaseInlineImage,releaseInlineImage
mse,B1,CEM ,btn1InlineImage,dlgFmtPosImage,dragInlineImage,,releaseInlineImage,releaseInlineImage
mse,B1,CEM  C,copyInlineImage,copyInlineImage,dragInlineImage,dragInlineImage,releaseInlineImage,releaseInlineImage

mse,B1,CTV ,beginVDrag,clearSetCols,dragVline,,endDragVline,
mse,B1,CTH ,beginHDrag,clearSetRows,dragHline,,endDragHline,
mse,B1,CTC ,selectColumnClick,clearSetCols,dragHline,,endDragVline,
mse,B2,CTC ,selectColumnClick,clearSetCols,dragHline,,endDragVline,

// special key binding for X11-style middle mouse selection (not to be confused with the clipboard)

mse,B2,CT ,pasteSelection,,,,,
mse,B2,CH ,pasteSelection,,,,,

mse,B3,CT ,contextText,,,,,
mse,B3,CVD ,contextText,,,,,
mse,B3,CM ,contextMisspellText,,,,,
mse,B3,CI ,contextImage,,,,,
mse,B3,CZ ,contextImage,,,,,
mse,B3,CTF ,contextFrame,,,,,
mse,B3,CPO ,contextPosObject,,,,,
mse,B3,CEM ,contextEmbedLayout,,,,,
mse,B3,CMA ,editLatexEquation,editLatexEquation,selectMath,,,

mse,B3,CH ,contextHyperlink,,,,,
mse,B3,CTO ,contextTOC,,,,,

mse,B3,CV ,contextRevision,,,,,

//  Button-4, Mouse wheel (3 lines up)... yes, a hack.

mse,B4,CU ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CU  C,zoomIn,zoomIn,,,,
mse,B4,CT ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CT  C,zoomIn,zoomIn,,,,
mse,B4,CM ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CM  C,zoomIn,zoomIn,,,,
mse,B4,CL ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CL  C,zoomIn,zoomIn,,,,
mse,B4,CR ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CR  C,zoomIn,zoomIn,,,,
mse,B4,CI ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CI  C,zoomIn,zoomIn,,,,
mse,B4,CZ ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CZ  C,zoomIn,zoomIn,,,,
mse,B4,CF ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CF  C,zoomIn,zoomIn,,,,
mse,B4,CH ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CH  C,zoomIn,zoomIn,,,,
mse,B4,CV ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CV  C,zoomIn,zoomIn,,,,
mse,B4,CTV ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CTV  C,zoomIn,zoomIn,,,,
mse,B4,CTH ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CTH  C,zoomIn,zoomIn,,,,
mse,B4,CTO ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CTO  C,zoomIn,zoomIn,,,,
mse,B4,CVD ,scrollWheelMouseUp,scrollWheelMouseUp,,,,
mse,B4,CVD  C,zoomIn,zoomIn,,,,

//  Button-5, Mouse wheel (3 lines down)

mse,B5,CU ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CU  C,zoomOut,zoomOut,,,,
mse,B5,CT ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CT  C,zoomOut,zoomOut,,,,
mse,B5,CM ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CM  C,zoomOut,zoomOut,,,,
mse,B5,CL ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CL  C,zoomOut,zoomOut,,,,
mse,B5,CR ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CR  C,zoomOut,zoomOut,,,,
mse,B5,CI ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CI  C,zoomOut,zoomOut,,,,
mse,B5,CZ ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CZ  C,zoomOut,zoomOut,,,,
mse,B5,CF ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CF  C,zoomOut,zoomOut,,,,
mse,B5,CH ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CH  C,zoomOut,zoomOut,,,,
mse,B5,CV ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CV  C,zoomOut,zoomOut,,,,
mse,B5,CTV ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CTV  C,zoomOut,zoomOut,,,,
mse,B5,CTH ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CTH  C,zoomOut,zoomOut,,,,
mse,B5,CVD ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CVD  C,zoomOut,zoomOut,,,,
mse,B5,CTO ,scrollWheelMouseDown,scrollWheelMouseDown,,,,
mse,B5,CTO  C,zoomOut,zoomOut,,,,

//  nvk,none,_S,_C,_S_C, _A,_A_S,_A_C,_A_C_S

nvk,BACKSPACE,delLeft,delLeft,delBOW,,,,,,
nvk,SPACE,insertSpace,insertSpace,togglePlain,insertNBSpace,insertNBZWSpace,insertZWJoiner,,,
nvk,TAB,insertTab,insertTabShift,cycleWindows,cycleWindowsBck,,,,,
nvk,RETURN,insertParagraphBreak,insertLineBreak,insertPageBreak,insertColumnBreak,insertSectionBreak,,,,
nvk,ESCAPE,doEscape,doEscape,doEscape,doEscape,,doEscape,doEscape,doEscape,
nvk,PAGEUP,warpInsPtPrevScreen,extSelScreenUp,warpInsPtPrevPage,extSelPageUp,,,warpInsPtBOP,,
nvk,PAGEDOWN,warpInsPtNextScreen,extSelScreenDown,warpInsPtNextPage,extSelPageDown,,,warpInsPtEOP,,
nvk,END,warpInsPtEOL,extSelEOL,warpInsPtEOD,extSelEOD,,,,,
nvk,HOME,warpInsPtBOL,extSelBOL,warpInsPtBOD,extSelBOD,,,,,
nvk,LEFT,warpInsPtLeft,extSelLeft,warpInsPtBOW,extSelBOW,toggleUnIndent,,,,
nvk,UP,warpInsPtPrevLine,extSelPrevLine,warpInsPtBOB,extSelBOB,,,,,
nvk,RIGHT,warpInsPtRight,extSelRight,warpInsPtEOW,extSelEOW,toggleIndent,,,,
nvk,DOWN,warpInsPtNextLine,extSelNextLine,warpInsPtEOB,extSelEOB,,,,,
nvk,MENU_SHORTCUT,contextMenu,,,,,,,,
nvk,INSERT,toggleInsertMode,paste,copy,,,,,,
nvk,DELETE,delRight,cut,delEOW,,,,,,

nvk,F1,helpContents,,,,,,,,
nvk,F3,findAgain,rotateCase,,,,,,,
nvk,F4,,,closeWindow,,querySaveAndExit,,,,
nvk,F7,dlgSpell,,,,,,,,
nvk,F10,,contextMenu,,,,,,,
nvk,F11,viewFullScreen,,,,,,,,
nvk,F12,cycleInputMode,,,,,,,,	

//nvk,DEAD_GRAVE,deadgrave,deadgrave,,, ,,,,
//nvk,DEAD_ACUTE,deadacute,deadacute,,, ,,,,
//nvk,DEAD_CIRCUMFLEX,deadcircumflex,deadcircumflex,,, ,,,,
//nvk,DEAD_TILDE,deadtilde,deadtilde,,, ,,,,
//nvk,DEAD_MACRON,deadmacron,deadmacron,,, ,,,,
//nvk,DEAD_BREVE,deadbreve,deadbreve,,, ,,,,
//nvk,DEAD_ABOVEDOT,deadabovedot,deadabovedot,,, ,,,,
//nvk,DEAD_DIAERESIS,deaddiaeresis,deaddiaeresis,,, ,,,,
//nvk,DEAD_DOUBLEACUTE,deaddoubleacute,deaddoubleacute,,, ,,,,
//nvk,DEAD_CARON,deadcaron,deadcaron,,, ,,,,
//nvk,DEAD_CEDILLA,deadcedilla,deadcedilla,,, ,,,,
//nvk,DEAD_OGONEK,deadogonek,deadogonek,,, ,,,,

// key, char, none, _C, _A, _A _C

key,	0x21,insertData,,,
key,	0x22,insertData,,,					
key, 0x23,insertData,,,
key,	0x24, insertData,,,
key,	0x25, insertData,,,
key, 0x26,insertData,,,
key, 0x27,insertData,,,
key, 0x28,insertOpeningParenthesis,,,
key, 0x29,insertClosingParenthesis,,,
key, 0x2a, insertData,viewPara,,
key, 0x2b, insertData,zoomIn,,
key, 0x2c,insertData,,,
key, 0x2d, insertData,,,
key, 0x2e, insertData,pasteSpecial,,
key, 0x2f,insertData,,,
key, 0x30,insertData,,,
key, 0x34,insertData,,,
key, 0x36,insertData,,,
key, 0x38,insertData,,,
key, 0x3a,insertData,,,
key, 0x3b,insertData,,,
key, 0x3c,insertData,fontSizeDecrease,,insertRLM
key, 0x3d,insertData,toggleSuper,,
key, 0x3e,insertData,,,
key, 0x40,insertData,,,
key, 0x41,insertData,selectAll,,				
key, 0x42,insertData,toggleBold,,				
key, 0x43,insertData,copy,,				
key, 0x44,insertData,dlgFont,,				
key, 0x45,insertData,alignCenter,,				
key, 0x46,insertData,find,,				
key, 0x47,insertData,go,,				
key, 0x48,insertData,replace,,				
key, 0x49,insertData,toggleItalic,,				
key, 0x4a,insertData,alignJustify,,				
key, 0x4b,insertData,toggleStrike,,				
key, 0x4c,insertData,alignLeft,,				
key, 0x4d,insertData,insSymbol,,				
key, 0x4e,insertData,fileNewUsingTemplate,,				
key, 0x4f,insertData,fileOpen,,				
key, 0x50,insertData,print,,				
key, 0x51,insertData,querySaveAndExit,,				
key, 0x52,insertData,alignRight,,
key, 0x53,insertData,fileSaveAs,,				
key, 0x54,insertData,toggleOline,,				
key, 0x55,insertData,toggleUline,,				
key, 0x56,insertData,paste,,				
key, 0x57,insertData,closeWindow,,				
key, 0x58,insertData,cut,,				
key, 0x59,insertData,redo,,				
key, 0x5a,insertData,undo,,				
key, 0x5b,insertOpeningParenthesis,editHeader,,				
key, 0x5c,insertData,removeHeader,,				
key, 0x5d,insertClosingParenthesis,editFooter,,				
key, 0x5e,insertData,removeFooter,,				
key, 0x5f,insertData,,,				
key, 0x60,insertData,,,				
key, 0x61,insertData,selectAll,,				
key, 0x62,insertData,toggleBold,,				
key, 0x63,insertData,copy,,				
key, 0x64,insertData,dlgFont,,				
key, 0x65,insertData,alignCenter,,				
key, 0x66,insertData,find,,				
key, 0x67,insertData,go,,				
key, 0x68,insertData,replace,,				
key, 0x69,insertData,toggleItalic,,				
key, 0x6a,insertData,alignJustify,,				
key, 0x6b,insertData,toggleStrike,,				
key, 0x6c,insertData,alignLeft,,				
key, 0x6d,insertData,insSymbol,,				
key, 0x6e,insertData,fileNew,,				
key, 0x6f,insertData,fileOpen,,				
key, 0x70,insertData,print,,				
key, 0x71,insertData,querySaveAndExit,,				
key, 0x72,insertData,alignRight,,				
key, 0x73,insertData,fileSave,,				
key, 0x74,insertData,toggleOline,,				
key, 0x75,insertData,toggleUline,,				
key, 0x76,insertData,paste,,				
key, 0x77,insertData,closeWindow,,				
key, 0x78,insertData,cut,,				
key, 0x79,insertData,redo,,				
key, 0x7a,insertData,undo,,				
key, 0x7b,insertOpeningParenthesis,,,				
key, 0x7c,insertData,,,				
key, 0x7d,insertClosingParenthesis,,,				
key, 0x7e,insertData,,,				

key, 0xa0,insertNBSpace,,,				
key, 0xa1,insertData,,,				
key, 0xa2,insertData,,,				
key, 0xa3,insertData,,,				
key, 0xa4,insertData,,,				
key, 0xa5,insertData,,,				
key, 0xa6,insertData,,,					
key, 0xa7,insertData,,,					
key, 0xa8,insertData,,,					
key, 0xa9,insertData,,,					
key, 0xaa,insertData,,,					
key, 0xab,insertData,,,					
key, 0xac,insertData,,,					
key, 0xad,insertData,,,					
key, 0xae,insertData,,,					
key, 0xaf,insertData,,,					
key, 0xb0,insertData,,,					
key, 0xb1,insertData,,,					
key, 0xb2,insertData,,,					
key, 0xb3,insertData,,,					
key, 0xb4,insertData,,,					
key, 0xb5,insertData,,,					
key, 0xb6,insertData,,,					
key, 0xb7,insertData,,,					
key, 0xb8,insertData,,,					
key, 0xb9,insertData,,,					
key, 0xba,insertData,,,					
key, 0xbb,insertData,,,					
key, 0xbc,insertData,,,					
key, 0xbd,insertData,,,					
key, 0xbe,insertData,,,					
key, 0xbf,insertData,,,					
key, 0xc0,insertData,,,					
key, 0xc1,insertData,,,					
key, 0xc2,insertData,,,					
key, 0xc3,insertData,,,					
key, 0xc4,insertData,,,					
key, 0xc5,insertData,,,					
key, 0xc6,insertData,,,					
key, 0xc7,insertData,,,					
key, 0xc8,insertData,,,					
key, 0xc9,insertData,,,					
key, 0xca,insertData,,,					
key, 0xcb,insertData,,,					
key, 0xcc,insertData,,,					
key, 0xcd,insertData,,,					
key, 0xce,insertData,,,					
key, 0xcf,insertData,,,					
key, 0xd0,insertData,,,					
key, 0xd1,insertData,,,					
key, 0xd2,insertData,,,					
key, 0xd3,insertData,,,					
key, 0xd4,insertData,,,					
key, 0xd5,insertData,,,					
key, 0xd6,insertData,,,					
key, 0xd7,insertData,,,					
key, 0xd8,insertData,,,					
key, 0xd9,insertData,,,					
key, 0xda,insertData,,,					
key, 0xdb,insertData,,,					
key, 0xdc,insertData,,,					
key, 0xdd,insertData,,,					
key, 0xde,insertData,,,					
key, 0xdf,insertData,,,					
key, 0xe0,insertData,,,					
key, 0xe1,insertData,,,					
key, 0xe2,insertData,,,					
key, 0xe3,insertData,,,					
key, 0xe4,insertData,					
key, 0xe5,insertData,,,					
key, 0xe6,insertData,,,					
key, 0xe7,insertData,,,					
key, 0xe8,insertData,,,					
key, 0xe9,insertData,,,					
key, 0xea,insertData,,,					
key, 0xeb,insertData,,,					
key, 0xec,insertData,,,					
key, 0xed,insertData,,,					
key, 0xee,insertData,,,					
key, 0xef,insertData,,,					
key, 0xf0,insertData,,,					
key, 0xf1,insertData,,,					
key, 0xf2,insertData,,,					
key, 0xf3,insertData,,,					
key, 0xf4,insertData,,,					
key, 0xf5,insertData,,,					
key, 0xf6,insertData,,,					
key, 0xf7,insertData,,,					
key, 0xf8,insertData,,,					
key, 0xf9,insertData,,,					
key, 0xfa,insertData,,,					
key, 0xfb,insertData,,,					
key, 0xfc,insertData,,,					
key, 0xfd,insertData,,,					
key, 0xfe,insertData,,,					
key, 0xff,insertData,,,					
"""
        return myone
    
